SystemOrganization addCategory: #Metaprogramacion!

!ClassDescription methodsFor: '*Metaprogramacion' stamp: 'SebastianGarbi 6/19/2013 20:35'!
lookForMisingImplementors: aMessage
	self methodDict at: aMessage  ifAbsent: [ Error signal: 'No existe el Mensaje'  ] .
	Error signal: 'El Metodo no es abstracto'.
	! !

TestCase subclass: #MetaprogamacionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/19/2013 21:02'!
test01LookForMissingImplementorsShouldRaiseAnExceptionWhenMessageDoesNotExists
	
	self should: [ClasePruebaSinMetodosPropios lookForMisingImplementors: #mensajeQueNoExiste]  raise: Error withExceptionDo: [ :anError |  self assert: anError messageText = 'No existe el Mensaje'].
	 ! !

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/19/2013 21:02'!
test02LookForMissingImplementorsShouldRaiseAnExceptionWhenMessageDoesNotExists
	
	self should: [ClasePruebaSinMetodosPropios class lookForMisingImplementors: #mensajeQueNoExiste]  raise: Error withExceptionDo: [ :anError |  self assert: anError messageText = 'No existe el Mensaje'].
	 ! !

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/22/2013 18:23'!
test03LookForMissingImplementorsShouldRaiseAnExceptionWhenMessageIsNotAbstract
	
	self should: [ClasePruebaSinMetodosAbstractos  lookForMisingImplementors: #mensajeNoAbstracto]  raise: Error withExceptionDo: [ :anError |  self assert: anError messageText = 'El Metodo no es abstracto'].
	 ! !

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/22/2013 19:39'!
test04LookForMissingImplementorsMustReturnEmptyCollectionWhenNoImplementorIsMissing
	
	self assert: (ClasePruebaConMetodosAbstractosCompletamenteImplementada  lookForMisingImplementors: #mensajeAbstracto) = Collection new
	 ! !

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/22/2013 18:37'!
test05LookForMissingImplementorsMustReturnTrueWhenAnimplementorIsMissing
	
	self should: [ClasePruebaConMetodosAbstractos  lookForMisingImplementors: #mensajeAbstracto]  raise: Error withExceptionDo: [ :anError |  self assert: anError messageText = 'El Metodo no es abstracto'].
	 ! !

Object subclass: #ClasePruebaConMetodosAbstractosCompletamenteImplementada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClasePruebaConMetodosAbstractosCompletamenteImplementada methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/22/2013 19:01'!
mensajeAbstracto
	self subclassResponsibility.! !

ClasePruebaConMetodosAbstractosCompletamenteImplementada subclass: #ClasePruebaHijaQueImplementaElMensaje
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClasePruebaHijaQueImplementaElMensaje methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/22/2013 19:01'!
mensajeAbstracto 
	^true.! !

Object subclass: #ClasePruebaConMetodosAbstractosConHijaVaga
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClasePruebaConMetodosAbstractosConHijaVaga subclass: #ClasePruebaHijaQueNoImplementaElMensaje
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

Object subclass: #ClasePruebaSinMetodosAbstractos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClasePruebaSinMetodosAbstractos methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/22/2013 18:26'!
mensajeNoAbstracto
	 ^true.! !

Object subclass: #ClasePruebaSinMetodosPropios
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!
